## Overall Comparison:

The benchmarking results highlight the strengths and weaknesses of each
library in different tasks. SkiaSharp excels in image conversion tasks
due to its fast processing time and low memory usage. EmguCV, while
consuming more memory, provides the best performance for pixel iteration
tasks, making it suitable for complex image processing operations.
ImageSharp, although efficient in memory usage for pixel iteration,
falls short in image conversion performance.

The decision to adopt SkiaSharp for image conversion and EmguCV for
complex image processing is based on a balance between performance and
cost. SkiaSharp’s superior performance in image conversion and EmguCV’s
comparable performance to ImageSharp, combined with cost savings, make
them the preferred choices for their respective tasks.

## Key Insights:

-   **SkiaSharp** showed excellent performance for **image conversion**,
    with both the fastest time (63.97 ms) and the least memory
    allocation (\~58 KB). This makes it an ideal choice for **image
    conversion tasks**.

-   **EmguCV** performed best for **pixel iteration** with a fast mean
    time of **85.49 ms**, though its memory consumption was higher
    (\~170 MB). The extensive **garbage collections** in EmguCV indicate
    high memory usage, but the performance benefits outweigh the memory
    cost for more complex operations.

-   **ImageSharp** consumed minimal memory for **pixel iteration** (\~20
    KB), but its **image conversion** performance lagged behind, taking
    significantly more time than SkiaSharp and consuming more memory
    (\~5.67 MB).

## Meeting Outcome and Final Decision:

-   **SkiaSharp** will be adopted for **image conversion** tasks due to
    its superior performance.

-   **EmguCV** will be the preferred choice for **complex image
    processing**. Although its memory consumption is higher than
    **ImageSharp**, the performance between the two is similar. However,
    the increased memory usage of **EmguCV** is within a manageable
    range for our needs. The primary reason for choosing **EmguCV** is
    the significant cost savings, as **ImageSharp** is considerably more
    expensive, and switching to **EmguCV** allows us to reduce licensing
    costs while maintaining comparable performance.
