# Performance Metrics

## Image Conversion

Image loading time—often measured as part of an image conversion
test—quantifies the duration required to:

-   **Load an image from disk:** This involves reading the file and
    decoding the image data.

-   **Perform a format conversion:** Typically, the image is converted
    from one format to another (e.g., JPG to PNG), simulating a common
    operation in many applications.

-   **Save the processed image back to disk.**

This metric is crucial because it directly impacts user experience in
applications where quick display and manipulation of images are
required. In scenarios such as web services or interactive applications,
delays in image loading can degrade performance noticeably.

## Pixel Iteration

Pixel iteration measures the time taken to traverse every pixel in an
image and apply a simple operation—typically converting each pixel to
grayscale. This metric isolates:

-   **Low-level processing efficiency:** Since many image operations
    (e.g., filtering, transformations) involve per-pixel computations,
    the speed at which a library can iterate over pixel data is a
    fundamental indicator of its performance.

-   **Scalability:** As image resolutions increase, efficient
    pixel-level operations become critical.

These two metrics were selected because they represent two complementary
aspects of image processing: the high-level overhead of loading and
converting images, and the low-level efficiency of pixel manipulation.
