# Pixel Iteration Benchmark Results

On the other hand, the pixel iteration benchmark aimed to assess the
libraries’ abilities to process each pixel of an image. For ImageSharp,
the warm-up phase for pixel iteration took an average of 755
milliseconds, with the main iteration averaging 117.06 milliseconds per
cycle and a cumulative total of 12,461 milliseconds over 100 iterations.

<div id="tab:pixel-iteration">

| **Library**                       | **Warm-Up Time (ms)** | **Avg. Time Excl. Warm-Up (ms)** | **Total Time Incl. Warm-Up (ms)** |     |
|:----------------------------------|:----------------------|:---------------------------------|:----------------------------------|:----|
| **Library**                       | **Warm-Up Time (ms)** | **Avg. Time Excl. Warm-Up (ms)** | **Total Time Incl. Warm-Up (ms)** |     |
| **ImageSharp**                    |                       |                                  |                                   |     |
| **OpenCvSharp + SkiaSharp**       |                       |                                  |                                   |     |
| **Magick.NET**                    |                       |                                  |                                   |     |
| **Emgu CV + Structure.Sketching** |                       |                                  |                                   |     |
|                                   |                       |                                  |                                   |     |

Pixel Iteration Benchmark Results in milliseconds, showing the warm-up
time, average time excluding warm-up, and total time including warm-up
for each library or combination.

</div>

The performance landscape changed upon examining the results for
Magick.NET. This configuration recorded a warm-up time of approximately
12,149 milliseconds, and the main iterations averaged 2,054.18
milliseconds, resulting in an astronomical total of 217,567
milliseconds. As discussed earlier, OpenCvSharp and Emgu CV were chosen
in combinations with SkiaSharp and Structure.Sketching, respectively,
for the pixel iteration task. The results of these tests provide
insights into the performance of these libraries in scenarios where
pixel-level operations are required, such as image processing algorithms
or computer vision applications. The performance landscape also shifted
upon examining the results for OpenCvSharp. This configuration recorded
a warm-up time of approximately 813 milliseconds, and the main
iterations averaged 159.44 milliseconds, resulting in a total of 16,757
milliseconds. In contrast, Emgu CV delivered impressive results with a
warm-up time of 1,118 milliseconds and an average main iteration time of
118.87 milliseconds, culminating in a total of 13,005 milliseconds.

The table
<a href="#tab:pixel-iteration" data-reference-type="ref" data-reference="tab:pixel-iteration">1</a>
summarizes the pixel iteration benchmark results, highlighting the
warm-up and average times for each library combination. The data clearly
show that Emgu CV is the most efficient library for pixel iteration,
with the lowest average time of 118.87 milliseconds. ImageSharp and
OpenCvSharp follow closely behind, with average times of 117.06 and
159.44 milliseconds, respectively. In contrast, Magick.NET is
significantly slower, with an average time of 2,054.18
milliseconds.Graphical
<a href="#fig:pixel-iteration" data-reference-type="ref" data-reference="fig:pixel-iteration">[fig:pixel-iteration]</a>
depictions further highlight these performance differences.

<img src="media/log_2.png" style="width:5in" alt="image" /> <span
id="fig:pixel-iteration"
label="fig:pixel-iteration">\[fig:pixel-iteration\]</span>

The disparity between these figures
<a href="#fig:pixel-iteration" data-reference-type="ref" data-reference="fig:pixel-iteration">[fig:pixel-iteration]</a>
is telling. While Magick.NET excels in some aspects of image conversion,
it appears less suited for tasks involving pixel-by-pixel iteration,
given the significantly higher processing times. On the other hand, Emgu
CV and ImageSharp produce comparable main iteration times; however, when
considering the overall picture, the lower cumulative times of Emgu CV
make it a more appealing choice for pixel-level operations.

The visual comparisons elucidate that while ImageSharp and Emgu
CV+Structure.Sketching are closely matched in main iteration
performance, the excessive warm-up and overall times associated with
Magick.NET underscore its limitations for this specific task.
