# Rationale for Metric Selection

### Why These Metrics?

-   **Foundational Operations:** Both image loading and pixel iteration
    are ubiquitous in image processing workflows. Almost every
    operation—from simple transformations to complex filtering—builds
    upon these basic tasks.

-   **Reproducibility and Objectivity:** Measuring the time for these
    operations yields quantitative, repeatable data that can be used to
    objectively compare different libraries.

-   **Application Relevance:** Many real-world applications, including
    web services, mobile apps, and desktop software, require fast image
    loading for improved responsiveness and efficient pixel processing
    for real-time manipulation.

### Why Not Other Metrics?

While other metrics—such as memory usage, image saving speed, or complex
transformation performance—could also provide valuable insights, the
selected metrics were prioritized because:

-   **Simplicity:** The chosen metrics are straightforward to measure
    with minimal external dependencies.

-   **Isolation of Core Operations:** Focusing on these metrics allows
    for a clear comparison of the libraries’ core capabilities without
    conflating results with higher-level or library-specific
    optimizations.

-   **Baseline Performance Indicator:** They serve as a baseline against
    which more complex operations can later be contextualized if needed.
