## Overview

In this section, we outline the development effort estimation for
implementing image processing functionalities within our project. We
evaluate two primary approaches: custom development of an image
processing library and the integration of existing external libraries
such as OpenCV or ImageMagick.

## Custom Development of Image Processing Library

During our team discussions, we evaluated the possibility of developing
our own image processing library. While this would give us complete
control over the feature set, we found that it would require a
significant amount of effort **+100 story points**. For example:

-   Implementing basic functionality like converting **BMP to JPEG**
    alone would require approximately **40 story points**.

-   Expanding to cover the full range of necessary image processing
    features would take an impractically long time for the scope of the
    project.

Given these factors, developing an internal library from scratch was
deemed too resource-intensive, and we opted for an external solution.

We referenced the following resources for additional insights into the
complexity of image conversions:

-   [YouTube Video 1](https://www.youtube.com/watch?v=Kv1Hiv3ox8I)

-   [YouTube Video 2](https://www.youtube.com/watch?v=0me3guauqOU)

## Use alternative Image Processing Library

Based on our discussions, the implementation effort for integrating
either OpenCV or ImageMagick into our Imagegen and ImageProcessor NuGet
packages can only be estimated roughly at this stage. However, we
anticipate that the development effort will be approximately **20 or
more story points** for either solution. This estimation takes into
account the necessary feature scope and the complexity involved in
replacing our current image processing functionality.
