After evaluating the various alternatives and the effort required for
custom development, the team has decided to use a combination of **Emgu
CV** and **SkiaSharp** for our image processing needs.

-   **Reason for Decision:**

    -   **Emgu CV** provides powerful image processing capabilities,
        including pixel manipulation, resizing, and format conversions.
        It is built on OpenCV, which ensures high performance for tasks
        such as image resizing, cropping, color conversion, and basic
        filtering.

    -   **SkiaSharp** complements Emgu CV by providing robust 2D
        graphics rendering, efficient image creation, and handling of
        different image formats. It excels at drawing operations and
        layer composition, making it suitable for both simple and
        complex image manipulation scenarios.

-   **Why This Combination?**

    -   The combination of Emgu CV and SkiaSharp covers both the
        low-level, performance-critical image manipulation provided by
        Emgu CV and the high-level, efficient rendering and image
        handling offered by SkiaSharp. Together, they meet the project’s
        feature requirements with minimal integration effort. The
        one-time cost of **$799** for Emgu CV, while notable, seems
        reasonable given its extensive capabilities and the absence of
        recurring subscription fees.
