## Benchmark Overview

This benchmark evaluates the performance of image processing tasks
through three key metrics: Image Conversion, Pixel Iteration, and their
associated times. These metrics provide insight into both the initial
setup time and the efficiency of processing during steady-state
operations.

### Benchmark Metrics

#### Pixel Iteration:

-   **Warm-Up Time:** Time taken for the initial pixel operation during
    the first setup.

-   **Average Time:** Average time measured across 100 iterations,
    excluding warm-up; indicates processing efficiency.

-   **Total Time:** Cumulative time for all 100 iterations.

#### Image Conversion:

Time taken to load the image into memory and iterate through every pixel
in the image, applying a simple operation (converting to grayscale) and
then save the image.

### Benchmarking Resources

**Image used for this benchmarking:**
<img src="media/image1.png" style="width:0.16667in;height:0.16667in" alt="image" />
[Image
Link](https://dsext001-eu1-215dsi0708-3dswym.3dexperience.3ds.com/api/media/streammedia/id/E_f8pedmRKKh2YOrjjqJoQ/type/picture/key/l1/update/f79c98dbee35f056b55aeabe4f2b6845)

**Benchmarking Implementation repository:**
<img src="media/image1.png" style="width:0.16667in;height:0.16667in" alt="image" />
[Benchmarking Repository](https://gd-git.dsone.3ds.com/SFI19/sc-176)

## Benchmark Results:

<img src="media/image3.png" style="width:5.90069in;height:6.17625in" alt="image" />

| **Library**                       | **Benchmark**    | **Time (ms)** |
|:----------------------------------|:-----------------|:--------------|
| **Library**                       | **Benchmark**    | **Time (ms)** |
| **ImageSharp**                    | Image Conversion |               |
| **OpenCvSharp + SkiaSharp**       | Image Conversion |               |
| **Magick.NET + MagicScaler**      | Image Conversion |               |
| **Emgu CV + Structure.Sketching** | Image Conversion |               |

<img src="media/image4.png" style="width:7in;height:6.17625in" alt="image" />

| **Library**                       | **Benchmark**   | **Warm-Up Time (ms)** | **Avg. Time Excl. Warm-Up (ms)** | **Total Time Incl. Warm-Up (ms)** |
|:----------------------------------|:----------------|:----------------------|:---------------------------------|:----------------------------------|
| **Library**                       | **Benchmark**   | **Warm-Up Time (ms)** | **Avg. Time Excl. Warm-Up (ms)** | **Total Time Incl. Warm-Up (ms)** |
| **ImageSharp**                    | Pixel Iteration |                       |                                  |                                   |
| **OpenCvSharp + SkiaSharp**       | Pixel Iteration |                       |                                  |                                   |
| **Magick.NET + MagicScaler**      | Pixel Iteration |                       |                                  |                                   |
| **Emgu CV + Structure.Sketching** | Pixel Iteration |                       |                                  |                                   |
