This section outlines the performance metrics used to evaluate the image
processing libraries. The metrics focus on two primary tests: Image
Conversion and Pixel Iteration. Each test measures the time taken and
memory usage for specific image processing tasks, providing a
comprehensive assessment of each library’s performance.

## Performance Metrics

### Image Conversion Test

Measure the time taken to load an image and convert its format using
each library, as well as the memory usage during the process.

**Steps:**

1.  Load the image into memory.

2.  Convert the image to another format (e.g., JPG to PNG).

3.  Save the converted image to disk.

**Metrics:**

-   Time taken to load the image and to convert the image format.

-   Memory usage will be measured.

### Pixel Iteration Test

Measure the time taken and memory usage to iterate through all the
pixels of an image, which is often necessary for tasks like filtering,
color adjustments, or complex image processing operations.

**Steps:**

1.  Load the image into memory.

2.  Iterate through every pixel in the image, applying a simple
    operation (converting to grayscale).

**Metrics:**

-   Time taken to complete the pixel iteration process.

-   Memory usage during the pixel iteration process.
