| **Feature Category**                   | **Supported by OIIO**                                                                                                                                                                                                                                                           | **Not Natively Supported / Requires Custom Implementation**                                                                                                         |
|:---------------------------------------|:--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|:--------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| **Feature Category**                   | **Supported by OIIO**                                                                                                                                                                                                                                                           | **Not Natively Supported / Requires Custom Implementation**                                                                                                         |
| **Image Loading and Creation**         | \- **ImageInput:open**: Opens an image file for reading. - **ImageInput:read_image**: Reads image data. - **ImageOutput:create**: Creates a new image file for writing. - **ImageOutput:write_image**: Writes the image data. - **ImageBuf**: Can create an empty image buffer. | \- Asynchronous image loading (no equivalent to **Image.LoadAsync**).                                                                                               |
| **Image Processing and Manipulation**  | \- Basic pixel manipulation through scanlines/tiles. - **ImageBufAlgo** provides some algorithms for manipulation.                                                                                                                                                              | \- No built-in functions for **Clone**, **Mutate**, **Resize**, **Grayscale**. - Requires external libraries (e.g., OpenCV) or custom code for advanced processing. |
| **Pixel Formats**                      | \- Supports various pixel formats including RGBA, RGB, L (grayscale), YUV, etc. - **ImageBufAlgo:colorconvert** allows conversion between formats.                                                                                                                              | \- Specific formats like **Byte4**, **YCbCr** may require manual handling.                                                                                          |
| **Pixel Access and Manipulation**      | \- Provides pixel access through **ImageInput:read_scanline** and **ImageInput:read_tile**. - Can manipulate pixels by reading and writing scanlines/tiles.                                                                                                                     | \- No direct method like **ProcessPixelRows**; manual processing required.                                                                                          |
| **Image Metadata and Conversion**      | \- **ImageSpec**: Handles image metadata. - **ImageBuf**: Manages pixel data and metadata. - **ImageBufAlgo**: Offers conversion algorithms.                                                                                                                                    | \- Handling complex metadata and conversions might require custom implementation depending on needs.                                                                |
| **Creating and Disposing Instances**   | \- **ImageBuf**: Creates and manages image instances. - Resources automatically managed in C++ (via destructors).                                                                                                                                                               | \- Explicit disposal may be needed for resource-intensive operations, especially in languages without automatic garbage collection.                                 |
| **Cropping and Resizing**              | \- **ImageBufAlgo:crop**: Crops images. - **ImageBufAlgo:resize**: Resizes images with various techniques.                                                                                                                                                                      | \- No direct equivalent to **Mutate** for fluent transformations.                                                                                                   |
| **Encoding Images in Various Formats** | \- Supports encoding in multiple formats (BMP, JPEG, PNG, TIFF, **WebP**, etc.) via **ImageOutput**.                                                                                                                                                                            | \- none.                                                                                                                                                            |
| **Composing Image Layers**             | \- **ImageBufAlgo:paste**: Combines image layers or tiles.                                                                                                                                                                                                                      | \- No built-in methods equivalent to ImageSharp’s **Stitch** method.                                                                                                |
| **Resampling Methods**                 | \- **ImageBufAlgo:resample**: Provides resampling techniques.                                                                                                                                                                                                                   | \- Lacks a direct equivalent to the **IResampler** interface; resampling management is manual.                                                                      |
| **Saving the Image**                   | \- **ImageOutput:write_image**: Saves images to a file.                                                                                                                                                                                                                         | \- No asynchronous saving; requires standard async techniques for implementation.                                                                                   |
