| **Feature Category**                   | **Supported by SkiaSharp**                                                                                                                                                                                                                                                                                                             | **Not Natively Supported / Requires Custom Implementation**                                          |
|:---------------------------------------|:---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|:-----------------------------------------------------------------------------------------------------|
| **Feature Category**                   | **Supported by SkiaSharp**                                                                                                                                                                                                                                                                                                             | **Not Natively Supported / Requires Custom Implementation**                                          |
| **Image Loading and Creation**         | \- **SKBitmap.Decode**: Loads images from byte arrays or streams. - **SKBitmap**: Creates new bitmaps with specified dimensions and color types. - **SKImage.FromBitmap**: Creates an image from a bitmap. - **SKImage.FromEncodedData**: Loads images from encoded data.                                                              | \- No built-in asynchronous image loading (no equivalent to **Image.LoadAsync**).                    |
| **Image Processing and Manipulation**  | \- **SKBitmap.Copy**: Clones the bitmap. - **SKBitmap.Resize**: Resizes bitmaps with various filtering modes. - **SKBitmap.ExtractSubset**: Crops bitmaps. - **SKImage.FilterImage**: Applies filters like grayscale or other color transformations. - **SKColorFilter.CreateColorMatrix**: Provides additional color transformations. | \- No high-level fluent API like ImageSharp’s **Mutate** for chaining multiple operations.           |
| **Pixel Formats**                      | \- Supports various pixel formats like **SKColorType.Rgba8888**, **SKColorType.Bgra8888**, **SKColorType.Gray8**, etc. - **SKColorSpace**: Manages color space conversions.                                                                                                                                                            | \- Specific formats like **Byte4**, **YCbCr** may require custom conversion.                         |
| **Pixel Access and Manipulation**      | \- **SKBitmap.GetPixel** / **SetPixel**: Accesses and sets individual pixels. - **SKBitmap.Pixels**: Provides access to the pixel data for bulk manipulation.                                                                                                                                                                          | \- No direct method like **ProcessPixelRows**; manual processing of pixel rows is required.          |
| **Image Metadata and Conversion**      | \- **SKImageInfo**: Manages basic image properties such as dimensions and color type. - **SKImage.Encode**: Converts images into various formats like PNG, JPEG, **WebP**, etc.                                                                                                                                                        | \- Limited support for complex metadata handling compared to ImageSharp and OIIO.                    |
| **Creating and Disposing Instances**   | \- **SKBitmap** and **SKImage**: Create and manage image instances. - Proper resource management using the **Dispose** method is necessary to free resources.                                                                                                                                                                          | \- No direct equivalent to **Image\<Rgba32>**; pixel format and dimensions must be managed manually. |
| **Cropping and Resizing**              | \- **SKBitmap.ExtractSubset**: Crops images. - **SKBitmap.Resize**: Resizes images with different resampling techniques.                                                                                                                                                                                                               | \- No built-in equivalent to ImageSharp’s **Mutate** method for complex transformations.             |
| **Encoding Images in Various Formats** | \- **SKImage.Encode**: Encodes images in multiple formats (e.g., PNG, JPEG, BMP, **WebP**).                                                                                                                                                                                                                                            | \- Custom handling might be needed for less common formats.                                          |
| **Composing Image Layers**             | \- **SKCanvas.DrawBitmap**: Composes images by drawing one bitmap onto another. - **SKPicture**: Records a sequence of drawing commands for later playback and compositing.                                                                                                                                                            | \- No built-in method equivalent to ImageSharp’s **Stitch** for seamless image stitching.            |
| **Resampling Methods**                 | \- **SKBitmap.Resize**: Provides resampling techniques during resizing operations.                                                                                                                                                                                                                                                     | \- No direct equivalent to **IResampler** interface; resampling techniques are more basic.           |
| **Saving the Image**                   | \- **SKImage.Encode**: Saves images to a stream or byte array in the desired format.                                                                                                                                                                                                                                                   | \- No built-in asynchronous saving method; async saving requires custom implementation.              |
