| **Feature Category**                   | **Supported by Gift**                                                                                                                                                                                                                                                                                 | **Not Natively Supported / Requires Custom Implementation**                                                                                                                                                        |
|:---------------------------------------|:------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|:-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| **Feature Category**                   | **Supported by Gift**                                                                                                                                                                                                                                                                                 | **Not Natively Supported / Requires Custom Implementation**                                                                                                                                                        |
| **Image Loading and Creation**         | \- Does not support Image Loading and Creation.                                                                                                                                                                                                                                                       | \- Does not support Image Loading and Creation.                                                                                                                                                                    |
| **Image Processing and Manipulation**  | \- **Clone, Resize, ConvertToGrayscale**: Supports advanced image processing tasks. - **Transformations, Annotations**: Transformations supported but Annotations not supported. - **Image Enhancement**: Supports operations like sharpening, blurring, adjusting brightness and contrast, and more. | \- To clone an image, you can create a new image with the same dimensions and copy the pixel data. - Need to use **gift** for image transformations and another library like **gg** for annotations.               |
| **Pixel Formats**                      | \- Does not directly provide pixel format manipulation or conversion functionalities.                                                                                                                                                                                                                 | \- Need to write custom implementation.                                                                                                                                                                            |
| **Pixel Access and Manipulation**      | \- Does not provide pixel-level access and manipulation.                                                                                                                                                                                                                                              | \- **gift**’s built-in functions aren’t sufficient.                                                                                                                                                                |
| **Image Metadata and Conversion**      | \- Does not directly handle image metadata or conversion between different formats.                                                                                                                                                                                                                   | \- The **gift** package does not provide direct support for format conversion.                                                                                                                                     |
| **Creating and Disposing Instances**   | \- Does not directly support creating and disposing of instances.                                                                                                                                                                                                                                     | \- We create a **gift** processor with a specific filter. We need to apply the filter to an image. Once done, Go’s garbage collector will handle memory management.                                                |
| **Cropping and Resizing**              | \- **gift.Resize**: Resizes image to the specified dimensions. - **gift.Crop**: Crops image to the specified dimensions.                                                                                                                                                                              | \- For cropping, need to use a combination of **gift.Crop** and **gift.Resize**. While **gift** does not have a direct **Crop** function, we can achieve cropping by resizing and then applying the crop manually. |
| **Encoding Images in Various Formats** | \- Does not inherently include encoding images in different formats.                                                                                                                                                                                                                                  | \- Does not directly support **WebP**.                                                                                                                                                                             |
| **Composing Image Layers**             | \- Does not natively support composing image layers.                                                                                                                                                                                                                                                  | \- Can achieve layer composition by manually handling image layers using Go’s image processing libraries.                                                                                                          |
| **Resampling Methods**                 | \- Provides a variety of resampling methods for image.                                                                                                                                                                                                                                                | \- None; Resampling robustly supported.                                                                                                                                                                            |
| **Saving the Image**                   | \- Does not directly handle file I/O for saving.                                                                                                                                                                                                                                                      | \- To perform asynchronous saving, need to use Go’s concurrency features such as goroutines.                                                                                                                       |
